﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using LibreriaVirtual.Models;
using LibreriaVirtual.ViewModel;

namespace LibreriaVirtual.Controllers
{
    public class CarritoCompraController : Controller
    {
        private LibreriaVirtualEntities db = new LibreriaVirtualEntities();
        
        public ActionResult Index()
        {
            // Instanciamos el cart
            var car = CarritoCompra.GetCar(this.HttpContext);

            // Instanciamos nuestro ViewModel (ShoppingCartViewModel)
            var viewModel = new CarritoCompraViewModel
            {
                CarItems = car.GetCarItems(),
                CarTotal = car.GetTotal()
            };


            return View(viewModel);
        }
        public ActionResult AddToCart(int id, int TipoCompra)
        {

            var addLibro = db.Libros.Single(libro => libro.IdLibro == id);

            // Añadimos el course al cart
            var car = CarritoCompra.GetCar(this.HttpContext);
            car.AddToCar(addLibro,TipoCompra);

            return RedirectToAction("Index");
        }

        public ActionResult DeleteLibro(int id) {
            var cart = CarritoCompra.GetCar(this.HttpContext);
            cart.deleteLibro(id);

            return RedirectToAction("Index");
        }
     



      
        public ActionResult RemoveFromCart(int id, int tipoCompra, int numLibros)
        {
            var cart = CarritoCompra.GetCar(this.HttpContext);

            // Consultamos el nombre del course
            string tituloLibro = db.Carrito.Single(item => item.IdRecord == id).Libros.Titulo;

            // borramos del cart
            int itemCount = cart.RemoveFromCar(id, tipoCompra, numLibros);

            // Mensaje de confirmacion -> usamos nuestro ViewModel (ShoppingCartRemoveViewModel)
            var results = new ShoppingCartRemoveViewModel
            {
                Message = Server.HtmlEncode(tituloLibro) + " ha sido eliminado.",
                CartTotal = cart.GetTotal(),
                CartCount = cart.GetCount(),
                ItemCount = itemCount,
                DeleteId = id
            };

            // Serializamos el result con JSON
            return Json(results, JsonRequestBehavior.AllowGet);
        }

       
    }
}
