﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using LibreriaVirtual.Models;
using System.Web.Script.Serialization;
using System.Xml;

namespace LibreriaVirtual.Controllers
{
    public class CategoriasController : Controller
    {

        LibreriaVirtualEntities db = new LibreriaVirtualEntities();
        
      
        public ActionResult Index()
        {
            return View();
        }

        [Authorize]
        public ActionResult Listado()
        {
            return View();
        }
        public ActionResult LibrosCategoria(int id)
        {
            Categorias cat = db.Categorias.Single(l => l.IdCategoria == id);
            ViewData["idCategoria"] = cat.IdCategoria;
            ViewData["sCategoria"] = cat.Nombre;
            return View();
        }
        public string GetSelectCategorias(bool bVacio)
        {
         
            var oCategorias = (from p in db.Categorias select p).ToList();
           
            var oList = new System.Collections.ArrayList();
            var sList = "";
       
            foreach (var p in oCategorias)
            {
               
                if (p.IdCategoria == 1 & bVacio==true) {
                    sList += p.IdCategoria + ":" + p.Nombre + ";";
 
                }else if (p.IdCategoria!=1){
                    sList += p.IdCategoria + ":" + p.Nombre + ";";
                
                }
             
            }
            if (sList.Length != 0)
            {
                sList = sList.Substring(0, sList.Length - 1);
            }
        
          
            var oCat = new
            {
                value = sList
            };

            return sList;
           
        }
           [Authorize]
        public ActionResult ListadoJQGrid(int page,int rows, string sidx,string sord)
        {


            var oCategorias = (from Cat in db.Categorias
                               join CatPadre in db.Categorias
                                   on Cat.IdCategoriaPadre equals CatPadre.IdCategoria into CatDesc
                               from CD in CatDesc.DefaultIfEmpty()
                               where Cat.IdCategoria!=1
                               select new {
                                idCategoria=Cat.IdCategoria,
                                nombreCategoria=Cat.Nombre,
                                idCategoriaPadre=Cat.IdCategoriaPadre,
                                nombreCatPadre= CD.Nombre
                               }).ToList();


            int contador = 1;
            var oList = new System.Collections.ArrayList();
            foreach (var p in oCategorias)
            {
                var oCell = new string[]{
                    Convert.ToString(p.idCategoria),
                    p.nombreCategoria,
                    Convert.ToString( p.idCategoriaPadre),
                    p.nombreCatPadre
               };
                var row = new
                {
                    id = contador,
                    cell = oCell
                };

                oList.Add(row);
                contador += 1;
            }

            var data = new
            {
                total = 3,
                page = 1,
                records = 20,
                rows = oList
            };

            return Json(data, JsonRequestBehavior.AllowGet);
        }

           [Authorize]
        [HttpPost]
        public String SaveCategoria(Categorias categoria)
        {
            if (ModelState.IsValid)
            {
              
                db.Categorias.Attach(categoria);
                db.ObjectStateManager.ChangeObjectState(categoria, EntityState.Modified);
                db.SaveChanges();
            }
            else { 
                
            }
            return "";
        }

   [Authorize]
        [HttpPost]
        public String Create(Categorias categoria)
        {
                db.Categorias.AddObject(categoria);
            
                db.SaveChanges();
                return "";
        }
        [Authorize]      
        public String eliminarCategoria(int idCategoria) {
            try
            {
                Categorias cat = db.Categorias.Single(l => l.IdCategoria == idCategoria);
                int nLibros = db.Libros.Where(lib => lib.IdCategoria == idCategoria).ToList().Count;
                if (nLibros == 0)
                {
                    db.Categorias.DeleteObject(cat);
                    db.SaveChanges();
                    return "Eliminado correctamente.";
                }
                else
                {
                    return "No se puede eliminar porque tiene libros asociados.";
                }
            }
            catch (Exception exception) {
                return exception.ToString();
            }          
        }

    }
}
