﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using LibreriaVirtual.Models;
using System.Web.Script.Serialization;
using System.Xml;

namespace LibreriaVirtual.Controllers
{
    public class LibrosController : Controller
    {
        private LibreriaVirtualEntities db = new LibreriaVirtualEntities();

        [Authorize]
        public ActionResult Listado() {
            return View();
        }
        
              
        public ActionResult GetDetalle(int id)
        {
            Libros libros = db.Libros.Single(l => l.IdLibro == id);
            return View(libros);
        }

        [Authorize]
        public string eliminarLibro(int idLibro)
        {
            try {
                //los libros no se eliminan solo le añadimos un parametro para diferenciarlo
                Libros libros = db.Libros.Single(l => l.IdLibro == idLibro);
                libros.FechaBaja = DateTime.Now;
                db.SaveChanges();
                return "Eliminado correctamente.";
            }catch (InvalidCastException e) {
              return e.ToString();
            }
        }

           [Authorize]
        [HttpPost]
        public String SaveLibro(Libros libros)
        {
            if (ModelState.IsValid)
            {
                db.Libros.AddObject(libros);
                db.ObjectStateManager.ChangeObjectState(libros, EntityState.Modified);
                
                db.SaveChanges();
            }
            return "";
        }

        [Authorize]
        [HttpPost]
        public String CreateLibro(Libros libros)
        {
       
            db.Libros.AddObject(libros);
            db.ObjectStateManager.ChangeObjectState(libros, EntityState.Added);

            db.SaveChanges();
         
            return "";
        }

        [Authorize]
        public ActionResult ListadoJQGrid()
        {
       
            //libros sin fecha de baja....
             var oLibros = (from cartItems in db.Libros
                          where cartItems.FechaBaja == null
                          select cartItems).ToList();

            int contador = 1;
            var oList = new System.Collections.ArrayList();
            foreach (var p in oLibros)
            {
                var oCell = new string[]{
                    Convert.ToString(p.IdLibro),
                    p.ISBN,
                    p.Titulo,
                    p.Autor,
                     Convert.ToString(p.IdCategoria),
                     Convert.ToString(p.Stock),
                     Convert.ToString(p.Precio),
                     Convert.ToString(p.PrecioEbook),
                    p.Observaciones,
                    p.Resumen,
                     Convert.ToString(p.esNovedad)
               };
                var row = new
                {
                    id = contador,
                    cell = oCell
                };

                oList.Add(row);
                contador += 1;
            }
            
            var data = new
            {
                total = 3,
                page = 1,
                records = 20,
                rows = oList
            };

            return Json(data, JsonRequestBehavior.AllowGet);
        }

                                     
              
        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}