﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using LibreriaVirtual.Models;
using System.Data;
using System.Data.Entity;

namespace LibreriaVirtual.Controllers
{
    public class PedidosController : Controller
    {

        private LibreriaVirtualEntities db = new LibreriaVirtualEntities();

        public ActionResult DatosCliente()
        {
            return View();
        }

        public String CrearPedido(Clientes oCliente) {
                       
            
            db.Clientes.AddObject(oCliente);
            db.ObjectStateManager.ChangeObjectState(oCliente, EntityState.Added);

             var idChange =   db.SaveChanges();
             var idCliente = oCliente.IdCliente;

             // Instanciamos el cart
             var car = CarritoCompra.GetCar(this.HttpContext);
             var CarItems = car.GetCarItems();
             var CarTotal = car.GetTotal();

            //Creamos un nuevo pedido
             var oPedido = new Pedidos();
             oPedido.IdCliente = idCliente;
             oPedido.PrecioTotal = CarTotal;
             oPedido.FechaPedido = DateTime.Now;
             db.Pedidos.AddObject(oPedido);
             db.ObjectStateManager.ChangeObjectState(oCliente, EntityState.Added);
             db.SaveChanges();
             var idPedido = oPedido.IdPedido;

            //Por cada libro creamos un PedidoDetalle y actualizamos el stock
            foreach ( Carrito linea in CarItems ){
                var oDetalle = new PedidosDetalle();
                Libros oLibro = db.Libros.Single(l => l.IdLibro == linea.IdLibro);
               

                 oDetalle.IdPedido = idPedido;
                 oDetalle.IdLibro=linea.IdLibro;
                 oDetalle.CantidadEbook=linea.NumeroEbook;
                 oDetalle.PrecioEbook = linea.Libros.PrecioEbook;
                 if (linea.Numero <= linea.Libros.Stock)
                 {
                     oDetalle.CantidadLibro = linea.Numero;
                     oLibro.Stock = oLibro.Stock - linea.Numero;
                 }
                 else {
                     oDetalle.CantidadLibro = linea.Libros.Stock;
                     oLibro.Stock = 0;
                 }
                
                 oDetalle.PrecioLibro = linea.Libros.Precio;
                 db.PedidosDetalle.AddObject(oDetalle);
                 db.ObjectStateManager.ChangeObjectState(oDetalle, EntityState.Added);
                 db.SaveChanges();

            }
                     
            
            return "Pedido creado;";
        }

    }
}
